#! /bin/sh -
#
# This is a very simple-minded test, which is intended to do no more
# than verify that the example programs do compile and run without
# error.

test_digest=`../../xoxa -dsha1 test.xml | sed 's/^[^ ]* *//'`

exit_status=0

### verify that xoxa_digest produces the right output
xoxa_digest_output=`../xoxa_digest test.xml | sed 's/^[^ ]* *//'`
if test $test_digest != $xoxa_digest_output; then
    echo "xoxa_digest BAD"
    exit_status=1
fi

### verify xoxa_outline produces the same digest to the stderr
../xoxa_outline <test.xml >tmp_outline.txt 2>tmp_outline.digest
if test $? = 0; then
    xoxa_outline_output=`cat tmp_outline.digest`
    if test $test_digest != $xoxa_digest_output; then
        echo "xoxa_outline BAD: expected $test_digest, got $xoxa_outline_output"
        exit_status=1
    fi
else
    echo "xoxa_outline failed"
    exit_status=1
fi

if test $exit_status -eq 0; then
    rm -f tmp*
fi

exit $exit_status
