#ifndef PGP_H_LOADED
#define PGP_H_LOADED 1

// The functions and structs in this header file are visible outside this module,
// but they are not part of the Xoxa public interface.

#include "util_types.h"
#include "pgp_types.h"
#include "xml_expat.h"

#if XOXA_PRIVATE_INTERFACE

#define CHANNEL_WRITE 1
#define CHANNEL_READ 0
Channel* new_channel(char writing_p); // call with non-zero to create a writing channel
void channel_free(Channel*);
int channel_add_buffer(Channel* ch, Buf* b); // can only be called with a writing channel
void subprocess_free(ProcessManager* pm);
int subprocess_send(ProcessManager* pm, const char* buf, size_t buflen);
ProcessManager* new_subprocess(char** cmd, ...);
ProcessManager* pgp_verify_detached(Channel* signature, Channel* status_info);
SignatureDetail* gpg_signature_init(SignatureDetail*);
SignatureDetail* gpg_parse_status(Channel* chatter, SignatureDetail* detail);
#endif /* XOXA_PRIVATE_INTERFACE */

void gpg_signature_free(SignatureDetail*);
int xoxa_pgp_verify_initialize(ParserState* PS);
SignatureDetail* xoxa_parse_for_pgp_verify(ParserState* PS);

// Name for the algorithm
//#define PGP_ALGORITHM_NAME "http://ns.nxg.me.uk/xoxa/algo#openpgp"
#define PGP_ALGORITHM_NAME "pgp"

#endif /* PGP_H_LOADED */
