#ifndef READ_UTIL_H
#define READ_UTIL_H 1

#include "util_types.h"
#include "xml_expat.h"


const char* xoxa_version_string(void);

#ifdef XOXA_PRIVATE_INTERFACE

#include <setjmp.h>

void fatal(const char* fmt, ...);
void warning(const char* fmt, ...);
void xoxa_set_error_message_(ParserState*, int abandon_parse_p, const char* fmt, ...);
void xoxa_abandon_parse_(ParserState*);
void xoxa_jmp_set_(ParserState*, jmp_buf*);
void xoxa_jmp_clear_(ParserState*);
int isxmlspace(const byte* p);

byte* copystring(const byte* s);

Buf* bufinit(void);
Buf* bufinit_with(const byte*);
Buf* bufprintf(Buf* B, const char* fmt, ...);
Buf* bufchar(Buf* B, byte c);
Buf* bufstrcpy(Buf* dst, const byte* src);
Buf* bufstrncpy(Buf* dst, const byte* src, const size_t len);
Buf* bufcrop(Buf* B);
byte* bufstring(Buf* B);
byte* bufstring_copy(Buf* B);
void bufreset(Buf* B);
size_t buflength(Buf*);
void buffree(Buf*);

int bufstrcmp(const byte* b1, const byte* b2);

#endif /* XOXA_PRIVATE_INTERFACE */

#endif /* READ_UTIL_H */
