/* GENERATED FILE -- DO NOT EDIT */


#ifndef XOXA_EXPAT_H_DEFINED
#define XOXA_EXPAT_H_DEFINED 1
#include <expat.h>
#include "xml_expat.h"
/** The Xoxa analogue of the Expat XML_Parser type. */
typedef ParserState* Xoxa_Parser;
/** Creates a new parser.  Because The Xoxa_... functions require namespace-aware parsing, this function acts exactly as `Xoxa_ParserCreateNS`. */
Xoxa_Parser Xoxa_ParserCreate(const XML_Char *encoding);
/** Creates a new parser. */
Xoxa_Parser Xoxa_ParserCreateNS(const XML_Char *encoding, XML_Char namespaceSeparator);
/** Creates a new parser.  Because The Xoxa_... functions require namespace-aware parsing, this function acts exactly as `Xoxa_ParserCreateNS`. */
Xoxa_Parser Xoxa_ParserCreate_MM(const XML_Char *encoding, const XML_Memory_Handling_Suite *memsuite, const XML_Char *namespaceSeparator);
/** Creates a new parser; see `XML_ExternalEntityParserCreate` */
Xoxa_Parser Xoxa_ExternalEntityParserCreate(Xoxa_Parser xoxa_parser, const XML_Char* context, const XML_Char* encoding);
/** Returns the last error string. */
const XML_LChar * Xoxa_ErrorString(enum XML_Error code);
/** Reports the Expat version (not the Xoxa version) */
const XML_LChar * Xoxa_ExpatVersion(void);
/** Reports the Expat version (not the Xoxa version) */
XML_Expat_Version Xoxa_ExpatVersionInfo(void);
/** Reports the Expat feature list (not any Xoxa features) */
const XML_Feature * Xoxa_GetFeatureList(void);
/** The analogue of XML_XmlDeclHandler */
void Xoxa_SetXmlDeclHandler(Xoxa_Parser xp, XML_XmlDeclHandler arg);
/** The analogue of XML_StartElementHandler */
void Xoxa_SetStartElementHandler(Xoxa_Parser xp, XML_StartElementHandler arg);
/** The analogue of XML_EndElementHandler */
void Xoxa_SetEndElementHandler(Xoxa_Parser xp, XML_EndElementHandler arg);
/** Sets both start and end element handlers */
void Xoxa_SetElementHandler(Xoxa_Parser xp, XML_StartElementHandler arg2, XML_EndElementHandler arg1);
/** The analogue of XML_StartCdataSectionHandler */
void Xoxa_SetStartCdataSectionHandler(Xoxa_Parser xp, XML_StartCdataSectionHandler arg);
/** The analogue of XML_EndCdataSectionHandler */
void Xoxa_SetEndCdataSectionHandler(Xoxa_Parser xp, XML_EndCdataSectionHandler arg);
/** The analogue of XML_StartNamespaceDeclHandler */
void Xoxa_SetStartNamespaceDeclHandler(Xoxa_Parser xp, XML_StartNamespaceDeclHandler arg);
/** The analogue of XML_EndNamespaceDeclHandler */
void Xoxa_SetEndNamespaceDeclHandler(Xoxa_Parser xp, XML_EndNamespaceDeclHandler arg);
/** Sets both start and end namespace handlers */
void Xoxa_SetNamespaceDeclHandler(Xoxa_Parser xp, XML_StartNamespaceDeclHandler arg2, XML_EndNamespaceDeclHandler arg1);
/** The analogue of XML_CharacterDataHandler */
void Xoxa_SetCharacterDataHandler(Xoxa_Parser xp, XML_CharacterDataHandler arg);
/** The analogue of XML_ProcessingInstructionHandler */
void Xoxa_SetProcessingInstructionHandler(Xoxa_Parser xp, XML_ProcessingInstructionHandler arg);
typedef int (*Xoxa_ExternalEntityRefHandler)(Xoxa_Parser p,
                                             const XML_Char *context,
                                             const XML_Char *base,
                                             const XML_Char *systemId,
                                             const XML_Char *publicId);
/** Sets an external entity reference handler.  The second argument is of type `Xoxa_ExternalEntityRefHandler`.  If `Xoxa_SetExternalEntityRefHandlerArg` is not called, then the handler is passed the `Xoxa_Parser` instance.  See the documentation for `XML_SetExternalEntityRefHandler`.
@param xoxa_parser a Xoxa_Parser instance
@param handler an Expat external entity handler
@return void */
void Xoxa_SetExternalEntityRefHandler(Xoxa_Parser xoxa_parser, Xoxa_ExternalEntityRefHandler handler);
/** Corresponds to `XML_SetExternalEntityRefHandlerArg`. */
void Xoxa_SetExternalEntityRefHandlerArg(Xoxa_Parser xoxa_parser, void* arg1);
/** The analogue of XML_SkippedEntityHandler */
void Xoxa_SetSkippedEntityHandler(Xoxa_Parser xp, XML_SkippedEntityHandler arg);
/** The Xoxa version of XML_SetCommentHandler */
void Xoxa_SetCommentHandler(Xoxa_Parser xp, XML_CommentHandler arg1);
/** The Xoxa version of XML_SetDefaultHandler */
void Xoxa_SetDefaultHandler(Xoxa_Parser xp, XML_DefaultHandler arg1);
/** The Xoxa version of XML_SetDefaultHandlerExpand */
void Xoxa_SetDefaultHandlerExpand(Xoxa_Parser xp, XML_DefaultHandler arg1);
/** The Xoxa version of XML_ParserReset */
XML_Bool Xoxa_ParserReset(Xoxa_Parser xp, const XML_Char* arg1);
/** The Xoxa version of XML_SetEntityDeclHandler */
void Xoxa_SetEntityDeclHandler(Xoxa_Parser xp, XML_EntityDeclHandler arg1);
/** The Xoxa version of XML_SetElementDeclHandler */
void Xoxa_SetElementDeclHandler(Xoxa_Parser xp, XML_ElementDeclHandler arg1);
/** The Xoxa version of XML_SetAttlistDeclHandler */
void Xoxa_SetAttlistDeclHandler(Xoxa_Parser xp, XML_AttlistDeclHandler arg1);
/** The Xoxa version of XML_SetDoctypeDeclHandler */
void Xoxa_SetDoctypeDeclHandler(Xoxa_Parser xp, XML_StartDoctypeDeclHandler arg2, XML_EndDoctypeDeclHandler arg1);
/** The Xoxa version of XML_SetStartDoctypeDeclHandler */
void Xoxa_SetStartDoctypeDeclHandler(Xoxa_Parser xp, XML_StartDoctypeDeclHandler arg1);
/** The Xoxa version of XML_SetEndDoctypeDeclHandler */
void Xoxa_SetEndDoctypeDeclHandler(Xoxa_Parser xp, XML_EndDoctypeDeclHandler arg1);
/** The Xoxa version of XML_SetUnparsedEntityDeclHandler */
void Xoxa_SetUnparsedEntityDeclHandler(Xoxa_Parser xp, XML_UnparsedEntityDeclHandler arg1);
/** The Xoxa version of XML_SetNotationDeclHandler */
void Xoxa_SetNotationDeclHandler(Xoxa_Parser xp, XML_NotationDeclHandler arg1);
/** The Xoxa version of XML_SetNotStandaloneHandler */
void Xoxa_SetNotStandaloneHandler(Xoxa_Parser xp, XML_NotStandaloneHandler arg1);
/** The Xoxa version of XML_SetUnknownEncodingHandler */
void Xoxa_SetUnknownEncodingHandler(Xoxa_Parser xp, XML_UnknownEncodingHandler arg2, void * arg1);
/** The Xoxa version of XML_DefaultCurrent */
void Xoxa_DefaultCurrent(Xoxa_Parser xp);
/** The Xoxa version of XML_SetReturnNSTriplet */
void Xoxa_SetReturnNSTriplet(Xoxa_Parser xp, int arg1);
/** Sets the user data passed to handlers. */
void Xoxa_SetUserData(Xoxa_Parser xp, void * arg1);
/** The Xoxa version of XML_SetEncoding */
enum XML_Status Xoxa_SetEncoding(Xoxa_Parser xp, const XML_Char * arg1);
/** The Xoxa version of XML_UseParserAsHandlerArg */
void Xoxa_UseParserAsHandlerArg(Xoxa_Parser xp);
/** The Xoxa version of XML_UseForeignDTD */
enum XML_Error Xoxa_UseForeignDTD(Xoxa_Parser xp, XML_Bool arg1);
/** The Xoxa version of XML_SetBase */
enum XML_Status Xoxa_SetBase(Xoxa_Parser xp, const XML_Char * arg1);
/** The Xoxa version of XML_GetBase */
const XML_Char * Xoxa_GetBase(Xoxa_Parser xp);
/** The Xoxa version of XML_GetSpecifiedAttributeCount */
int Xoxa_GetSpecifiedAttributeCount(Xoxa_Parser xp);
/** The Xoxa version of XML_GetIdAttributeIndex */
int Xoxa_GetIdAttributeIndex(Xoxa_Parser xp);
/** The Xoxa version of XML_Parse */
enum XML_Status Xoxa_Parse(Xoxa_Parser xp, const char * arg3, int arg2, int arg1);
/** The Xoxa version of XML_GetBuffer */
void * Xoxa_GetBuffer(Xoxa_Parser xp, int arg1);
/** The Xoxa version of XML_ParseBuffer */
enum XML_Status Xoxa_ParseBuffer(Xoxa_Parser xp, int arg2, int arg1);
/** The Xoxa version of XML_StopParser */
enum XML_Status Xoxa_StopParser(Xoxa_Parser xp, XML_Bool arg1);
/** The Xoxa version of XML_ResumeParser */
enum XML_Status Xoxa_ResumeParser(Xoxa_Parser xp);
/** The Xoxa version of XML_GetParsingStatus */
void Xoxa_GetParsingStatus(Xoxa_Parser xp, XML_ParsingStatus * arg1);
/** The Xoxa version of XML_SetParamEntityParsing */
int Xoxa_SetParamEntityParsing(Xoxa_Parser xp, enum XML_ParamEntityParsing arg1);
/** The Xoxa version of XML_GetErrorCode */
enum XML_Error Xoxa_GetErrorCode(Xoxa_Parser xp);
/** The Xoxa version of XML_GetCurrentLineNumber */
XML_Size Xoxa_GetCurrentLineNumber(Xoxa_Parser xp);
/** The Xoxa version of XML_GetCurrentColumnNumber */
XML_Size Xoxa_GetCurrentColumnNumber(Xoxa_Parser xp);
/** The Xoxa version of XML_GetCurrentByteIndex */
XML_Index Xoxa_GetCurrentByteIndex(Xoxa_Parser xp);
/** The Xoxa version of XML_GetCurrentByteCount */
int Xoxa_GetCurrentByteCount(Xoxa_Parser xp);
/** The Xoxa version of XML_GetInputContext */
const char * Xoxa_GetInputContext(Xoxa_Parser xp, int * arg2, int * arg1);
/** The Xoxa version of XML_FreeContentModel */
void Xoxa_FreeContentModel(Xoxa_Parser xp, XML_Content * arg1);
/** The Xoxa version of XML_MemMalloc */
void * Xoxa_MemMalloc(Xoxa_Parser xp, size_t arg1);
/** The Xoxa version of XML_MemRealloc */
void * Xoxa_MemRealloc(Xoxa_Parser xp, void * arg2, size_t arg1);
/** The Xoxa version of XML_MemFree */
void Xoxa_MemFree(Xoxa_Parser xp, void * arg1);
/** Frees both the Xoxa_Parser and the underlying Expat parser. */
void Xoxa_ParserFree(Xoxa_Parser P);
#endif /* XOXA_EXPAT_H_DEFINED */
